#!/usr/local/bin/pgoblin -f
  Copyright (C)2019..2020 @BABOLO http://www.babolo.ru/
--PKG = mini-cipa
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: version.pgoblin.m4,v 1.3 2020/09/10 21:27:34 babolo Exp $

#perform 0002  ###########################################################     ####
CREATE TABLE IF NOT EXISTS public.version
     ( pkg      text NOT NULL
     , protover text
     , major    int  NOT NULL
     , minor    text NOT NULL
     , comconf  bool
     , UNIQUE(pkg, protover)
     )
;
#perform 0002
CREATE UNIQUE INDEX IF NOT EXISTS version_p ON public.version(pkg) WHERE protover IS NULL;
#perform 0002
GRANT ALL ON public.version TO operator;
#perform 0002  ################################################################     ####
CREATE TABLE IF NOT EXISTS public.srcs
     ( pkg      text NOT NULL
     , major    int  NOT NULL
     , minor    text NOT NULL
     , PRIMARY KEY(pkg, major)
     )
;
#perform 0002
GRANT ALL ON public.srcs TO operator;
#perform 0002
CREATE OR REPLACE VIEW public.babolover AS
 SELECT pkg, s.major AS smj, s.minor AS smi, version.major AS vmj, version.minor AS vmi
  FROM       (SELECT DISTINCT ON(pkg) pkg, major, minor
               FROM public.srcs
              ORDER BY pkg, major, minor
             )s
   FULL JOIN public.version USING(pkg)
;
#perform 0002
GRANT SELECT ON public.babolover TO public;
#
